/*
	espr.c

	costruisce albero per valutare un'espressione
*/
#include <stdio.h>
#include "stringa.h"
#include "tree.h"

char piu[]="+";
char meno[]="-";
char per[]="*";
char diviso[]="/";

Tree termine(void);
Tree fattore(void);
Tree espressione(void);

void stampa(Tree t){
	if(!isTreeVuoto(t)){
		stampa(treeSin(t));
		printf("%s ",(char*)treeDato(t) );
		stampa(treeDes(t));
	}
}

void errore(char *s){
	strPrint();
	fputs(s,stderr);
	
	exit();
}



char* operazione( void ) {
	if(simbolo() == PIU) return piu;
	if(simbolo() == MENO) return meno;
	if(simbolo() == PER) return per;
	if(simbolo() == DIVISO) return diviso;
}


Tree espressione(  ){
	Tree t;
	char *op;

	t=termine();
	while( simbolo()==PIU || simbolo()==MENO ){
		op=operazione();
		scan();
		t=treeCrea(op, t, termine());
	}
	return t;
}

Tree termine( ){
	Tree t;
	char *op;
	t=fattore();
	while( simbolo()==PER || simbolo()==DIVISO ){
		op=operazione();
		scan();
		t=treeCrea(op, t, fattore());
	}
	return t;
}

Tree fattore( ){
	char *op;
	Tree t;

	if( simbolo()==COSTANTE ){
		op=numero();
		scan();
		return treeCrea(op, treeVuoto(), treeVuoto());
	}

	if( simbolo()==APEPAR ){
		scan();
		t=espressione();
		if( simbolo()==CHIPAR ){
			scan();
			return t;
		} else errore("manca parentesi");
	}
	errore("simbolo errato");
}

int isNumero( char *s ){
	return *s>='0' && *s<='9';
}

int isPiu( char *s ){
	return *s=='+';
}

int isPer( char *s ){
	return *s=='*';
}

int isMeno( char *s ){
	return *s=='-';
}

int isDiviso( char *s ){
	return *s=='/';
}

int strToNumero( char *s ){
	int n;

	sscanf(s, "%d", &n);
	return n;
}

int valuta( Tree t ){
	if( isNumero(treeDato(t)) )
		return strToNumero( treeDato(t) );
	if( isPiu(treeDato(t)) )
		return valuta( treeSin(t) ) + valuta( treeDes(t) );
	if( isPer(treeDato(t)) )
		return valuta( treeSin(t) ) * valuta( treeDes(t) );
	if( isDiviso(treeDato(t)) )
		return valuta( treeSin(t) ) / valuta( treeDes(t) );
	if( isMeno(treeDato(t)) )
		return valuta( treeSin(t) ) - valuta( treeDes(t) );
	
}

int main() {
	char buffer[256];
	Tree t;

	fgets(buffer, 256, stdin);
	strNew(buffer);

	scan();
	t=espressione();
	printf("\nAlbero\n");

	stampa(t);

	printf("\n\n");

	if( simbolo()!= ALT ) errore("terminazione errata");

	printf("\nRisultato: %d\n", valuta(t) );
}
